// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use app_stream_glib_sys;
#[cfg(any(feature = "v0_7_8", feature = "dox"))]
use glib::GString;
use glib::object::IsA;
use glib::translate::*;
use std::fmt;

glib_wrapper! {
    pub struct AgreementSection(Object<app_stream_glib_sys::AsAgreementSection, app_stream_glib_sys::AsAgreementSectionClass, AgreementSectionClass>);

    match fn {
        get_type => || app_stream_glib_sys::as_agreement_section_get_type(),
    }
}

impl AgreementSection {
    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    pub fn new() -> AgreementSection {
        unsafe {
            from_glib_full(app_stream_glib_sys::as_agreement_section_new())
        }
    }
}

#[cfg(any(feature = "v0_7_8", feature = "dox"))]
impl Default for AgreementSection {
    fn default() -> Self {
        Self::new()
    }
}

pub const NONE_AGREEMENT_SECTION: Option<&AgreementSection> = None;

pub trait AgreementSectionExt: 'static {
    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_description(&self, locale: Option<&str>) -> Option<GString>;

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_kind(&self) -> Option<GString>;

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_name(&self, locale: Option<&str>) -> Option<GString>;

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_description(&self, locale: Option<&str>, desc: &str);

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_kind(&self, kind: &str);

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_name(&self, locale: Option<&str>, name: &str);
}

impl<O: IsA<AgreementSection>> AgreementSectionExt for O {
    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_description(&self, locale: Option<&str>) -> Option<GString> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_agreement_section_get_description(self.as_ref().to_glib_none().0, locale.to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_kind(&self) -> Option<GString> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_agreement_section_get_kind(self.as_ref().to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn get_name(&self, locale: Option<&str>) -> Option<GString> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_agreement_section_get_name(self.as_ref().to_glib_none().0, locale.to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_description(&self, locale: Option<&str>, desc: &str) {
        unsafe {
            app_stream_glib_sys::as_agreement_section_set_description(self.as_ref().to_glib_none().0, locale.to_glib_none().0, desc.to_glib_none().0);
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_kind(&self, kind: &str) {
        unsafe {
            app_stream_glib_sys::as_agreement_section_set_kind(self.as_ref().to_glib_none().0, kind.to_glib_none().0);
        }
    }

    #[cfg(any(feature = "v0_7_8", feature = "dox"))]
    fn set_name(&self, locale: Option<&str>, name: &str) {
        unsafe {
            app_stream_glib_sys::as_agreement_section_set_name(self.as_ref().to_glib_none().0, locale.to_glib_none().0, name.to_glib_none().0);
        }
    }
}

impl fmt::Display for AgreementSection {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "AgreementSection")
    }
}
